#------------------------------------------------
# 				         IntraMessenger
#
# http://www.intramessenger.net
#------------------------------------------------


CREATE TABLE IM_USR_USER (
  ID_USER int(11) NOT NULL auto_increment ,
  USR_USERNAME varchar(20) NOT NULL default '',
  USR_NICKNAME varchar(20) NOT NULL default '',
  USR_NAME varchar(50) NOT NULL default '',
  USR_LEVEL tinyint NOT NULL default '0',
  ID_ROLE tinyint UNSIGNED NULL default NULL,
  USR_STATUS tinyint NOT NULL default '0',
  USR_PASSWORD varchar(40) NOT NULL default '',
  USR_CHECK varchar(15) NOT NULL default '',
  USR_DATE_CREAT date NOT NULL default '0000-00-00',
  USR_DATE_LAST date NOT NULL default '0000-00-00',
  USR_DATE_PASSWORD date NOT NULL default '0000-00-00',
  USR_DATE_ACTIVITY date NOT NULL default '0000-00-00',
  USR_DATE_BIRTH date NOT NULL default '0000-00-00',
  USR_VERSION varchar(6) NOT NULL default '',
  USR_COUNTRY_CODE char(2) NOT NULL default '',
  USR_LANGUAGE_CODE char(2) NOT NULL default '',
  USR_IP_ADDRESS varchar(39) NOT NULL default '',
  USR_AVATAR varchar(20) NOT NULL default '',
  USR_TIME_SHIFT SMALLINT NOT NULL default '0',
  USR_OS VARCHAR(5) NOT NULL default '',
  USR_EMAIL VARCHAR(80) NOT NULL default '',
  USR_PHONE VARCHAR(20) NOT NULL default '',
  USR_PWD_ERRORS SMALLINT NOT NULL default '0',
  USR_GENDER CHAR(1) NOT NULL default '',
  USR_NB_CONNECT SMALLINT NOT NULL default '0',
  USR_GET_ADMIN_ALERT tinyint NOT NULL default '0',
  USR_GET_OFFLINE_MSG tinyint NOT NULL default '2',
  USR_MAC_ADR CHAR(12) NOT NULL default '',
  USR_COMPUTERNAME VARCHAR(20) NOT NULL default '',
  USR_SCREEN_SIZE VARCHAR(10) NOT NULL default '',
  USR_EMAIL_CLIENT VARCHAR(40) NOT NULL default '',
  USR_BROWSER VARCHAR(40) NOT NULL default '',
  USR_OOO VARCHAR(5) NOT NULL default '',
  USR_RATING tinyint NOT NULL default '0',
  USR_ONLINE  tinyint NOT NULL default '0',
  USR_TIME_LOCK TIME NOT NULL default '00:00:00', 
  USR_REG VARCHAR(30) NOT NULL default '',
  PRIMARY KEY (ID_USER),
  UNIQUE KEY USR_USERNAME (USR_USERNAME),
  KEY USR_NICKNAME (USR_NICKNAME),
  KEY USR_NAME (USR_NAME),
  KEY USR_LEVEL (USR_LEVEL),
  KEY USR_DATE_CREAT (USR_DATE_CREAT),
  KEY USR_DATE_LAST (USR_DATE_LAST),
  KEY USR_GET_ADMIN_ALERT (USR_GET_ADMIN_ALERT)
) COMMENT='Users';

CREATE TABLE IM_CNT_CONTACT (
  ID_CONTACT int(11) NOT NULL auto_increment,
  ID_USER_1 int(11) NOT NULL default '0',
  ID_USER_2 int(11) NOT NULL default '0',
  CNT_STATUS tinyint NOT NULL default '0',
  CNT_NEW_USERNAME varchar(20) NOT NULL default '',
  CNT_USER_GROUP varchar(20) NOT NULL default '',
  CNT_RATING tinyint NOT NULL default '0',
  CNT_SOUND TINYINT UNSIGNED NOT NULL default '0',
  PRIMARY KEY  (ID_CONTACT),
  KEY ID_USER_1 (ID_USER_1),
  KEY ID_USER_2 (ID_USER_2)
) COMMENT='Users contact list';


CREATE TABLE IM_MSG_MESSAGE (
  ID_MESSAGE int(11) NOT NULL auto_increment,
  ID_USER_AUT int(11) NOT NULL default '0',
  ID_USER_DEST int(11) NOT NULL default '0',
  MSG_TEXT text NOT NULL,
  MSG_CR char(2) NOT NULL default '',
  MSG_ETAT tinyint NOT NULL default '0',
  MSG_TIME time NOT NULL default '00:00:00',
  MSG_DATE date NOT NULL default '0000-00-00',
  ID_CONFERENCE INT NOT NULL default '0',
  PRIMARY KEY  (ID_MESSAGE),
  KEY ID_USER_AUT (ID_USER_AUT),
  KEY ID_USER_DEST (ID_USER_DEST),
  KEY ID_CONFERENCE (ID_CONFERENCE)
) COMMENT='Messages';


CREATE TABLE IM_SES_SESSION (
  ID_SESSION int(11) NOT NULL auto_increment,
  ID_USER int(11) NOT NULL default '0',
  SES_STATUS tinyint NOT NULL default '0',
  SES_STARTDATE date NOT NULL default '0000-00-00',
  SES_STARTTIME time NOT NULL default '00:00:00',
  SES_LASTTIME time NOT NULL default '00:00:00',
  SES_IP_ADDRESS varchar(23) NOT NULL default '',
  SES_AWAY_REASON tinyint NOT NULL default '0',
  PRIMARY KEY  (ID_SESSION),
  UNIQUE KEY ID_USER (ID_USER),
  KEY SES_STATUS (SES_STATUS)
) COMMENT='Online users';



CREATE TABLE IM_GRP_GROUP (
  ID_GROUP INT NOT NULL AUTO_INCREMENT,
  GRP_NAME VARCHAR( 20 ) NOT NULL ,
  GRP_PRIVATE TINYINT NOT NULL DEFAULT '0',
  GRP_SHOUTBOX TINYINT NOT NULL DEFAULT '0',
  GRP_SBX_NEED_APPROVAL TINYINT NOT NULL DEFAULT '0',
  PRIMARY KEY  (ID_GROUP),
  UNIQUE KEY GRP_NAME (GRP_NAME)
) COMMENT = 'Group list';


CREATE TABLE IM_USG_USERGRP (
  ID_GROUP INT NOT NULL ,
  ID_USER INT NOT NULL ,
  USG_PENDING TINYINT NOT NULL DEFAULT '0',
  INDEX ( ID_GROUP , ID_USER )
) COMMENT = 'Users in groups';


CREATE TABLE IM_STA_STATS (
  STA_DATE DATE NOT NULL ,
  STA_NB_MSG MEDIUMINT UNSIGNED NOT NULL default '0',
  STA_NB_CREAT SMALLINT UNSIGNED NOT NULL default '0',
  STA_NB_SESSION SMALLINT UNSIGNED NOT NULL default '0',
  STA_NB_USR MEDIUMINT UNSIGNED NOT NULL default '0',
  STA_SBX_NB_MSG MEDIUMINT UNSIGNED NOT NULL default '0',
  STA_SF_NB_SHARE MEDIUMINT UNSIGNED NOT NULL default '0',
  STA_SF_NB_EXCHANGE MEDIUMINT UNSIGNED NOT NULL default '0',
  STA_SF_NB_DOWNLOAD MEDIUMINT UNSIGNED NOT NULL default '0',
  PRIMARY KEY ( STA_DATE )
) COMMENT = 'Statistics';


CREATE TABLE IM_CNF_CONFERENCE (
  ID_CONFERENCE INT NOT NULL AUTO_INCREMENT,
  ID_USER INT NOT NULL ,
  CNF_DATE_CREAT date NOT NULL default '0000-00-00',
  CNF_TIME_CREAT time NOT NULL default '00:00:00',
  PRIMARY KEY  (ID_CONFERENCE),
  KEY ID_USER (ID_USER)
) COMMENT = 'Conferences';


CREATE TABLE IM_USC_USERCONF (
  ID_CONFERENCE INT NOT NULL ,
  ID_USER INT NOT NULL ,
  USC_ACTIVE TINYINT NOT NULL DEFAULT '0',
  INDEX ( ID_CONFERENCE , ID_USER )
) COMMENT = 'Users in conferences';


CREATE TABLE IF NOT EXISTS IM_BAN_BANNED (
  BAN_TYPE char(1) NOT NULL,
  BAN_VALUE varchar(50) default '' NOT NULL,
  INDEX (BAN_TYPE, BAN_VALUE)
) COMMENT = 'Banned users/computers/IP';

CREATE TABLE IF NOT EXISTS IM_SRV_SERVERSTATE (
  ID_SERVER SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
  SRV_NAME varchar(60) NOT NULL,
  SRV_IP_ADDRESS varchar(23) NOT NULL default '',
  SRV_STATE TINYINT UNSIGNED NOT NULL default '0',
  SRV_STATE_DATE date NOT NULL default '0000-00-00',
  SRV_STATE_TIME time NOT NULL default '00:00:00',
  SRV_STATE_COMMENT varchar(150) default '' NOT NULL,
  PRIMARY KEY  (ID_SERVER),
  UNIQUE KEY SRV_NAME (SRV_NAME)
) COMMENT = 'Servers states';


CREATE TABLE IF NOT EXISTS IM_SBX_SHOUTBOX (
  ID_SHOUT MEDIUMINT UNSIGNED NOT NULL auto_increment,
  ID_GROUP_DEST SMALLINT UNSIGNED NOT NULL default '0',
  ID_USER_AUT MEDIUMINT NOT NULL,
  SBX_TEXT varchar(250) NOT NULL,
  SBX_TIME time NOT NULL,
  SBX_DATE date NOT NULL,
  SBX_DISPLAY TINYINT NOT NULL default '1',
  SBX_RATING TINYINT NOT NULL default '0',
  PRIMARY KEY  (ID_SHOUT),
  KEY SBX_IND_1 (SBX_DATE, SBX_TIME),
  KEY SBX_IND_2 (ID_SHOUT, ID_GROUP_DEST)
) COMMENT = 'ShoutBox';


CREATE TABLE IF NOT EXISTS IM_SBS_SHOUTSTATS (
  ID_USER_AUT MEDIUMINT NOT NULL,
  SBS_NB SMALLINT UNSIGNED NOT NULL default '1',
  SBS_NB_REJECT TINYINT UNSIGNED NOT NULL default '0',
  SBS_NB_VOTE_M SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'More',
  SBS_NB_VOTE_L SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Less',
  SBS_MAX_VOTE_M SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Score More',
  SBS_MAX_VOTE_L SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Score Less',
  SBS_NB_LAST_DATE SMALLINT UNSIGNED NOT NULL default '1' COMMENT 'Day quota',
  SBS_LAST_DATE date NOT NULL,
  SBS_NB_LAST_WEEK SMALLINT UNSIGNED NOT NULL default '1' COMMENT 'Week quota',
  SBS_LAST_WEEK TINYINT UNSIGNED NOT NULL,
  PRIMARY KEY  (ID_USER_AUT)
) COMMENT = 'Stats shoutbox';


CREATE TABLE IF NOT EXISTS IM_SBV_SHOUTVOTE (
  ID_SHOUT MEDIUMINT UNSIGNED NOT NULL,
  ID_USER_VOTE MEDIUMINT NOT NULL,
  ID_USER_AUT MEDIUMINT NOT NULL COMMENT 'For stats',
  SBV_DATE date NOT NULL,
  SBV_VOTE_M TINYINT NOT NULL COMMENT 'More',
  SBV_VOTE_L TINYINT NOT NULL COMMENT 'Less',
  PRIMARY KEY  (ID_SHOUT, ID_USER_VOTE),
  KEY SBV_IND_1 (ID_USER_AUT)
) COMMENT = 'Votes shoutbox';


CREATE TABLE IF NOT EXISTS IM_BMC_BOOKMCATEG (
  ID_BOOKMCATEG TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,
  BMC_TITLE varchar(80) NOT NULL,
  PRIMARY KEY  (ID_BOOKMCATEG)
) COMMENT = 'Bookmarks';


CREATE TABLE IF NOT EXISTS IM_BMK_BOOKMARK (
  ID_BOOKMARK SMALLINT UNSIGNED NOT NULL AUTO_INCREMENT,
  ID_BOOKMCATEG TINYINT UNSIGNED NULL DEFAULT NULL,
  ID_USER_AUT MEDIUMINT NOT NULL,
  BMK_URL varchar(250) NOT NULL,
  BMK_TITLE varchar(100) NOT NULL,
  BMK_DATE date NOT NULL,
  BMK_DISPLAY TINYINT NOT NULL default '1',
  BMK_RATING TINYINT NOT NULL default '0',
  PRIMARY KEY  (ID_BOOKMARK),
  UNIQUE KEY BMK_URL (BMK_URL),
  UNIQUE KEY BMK_TITLE (BMK_TITLE)
) COMMENT = 'Bookmarks';


CREATE TABLE IF NOT EXISTS IM_BMV_BOOKMVOTE (
  ID_BOOKMARK SMALLINT UNSIGNED NOT NULL,
  ID_USER_VOTE MEDIUMINT NOT NULL,
  ID_USER_AUT MEDIUMINT NOT NULL COMMENT 'For stats',
  BMV_DATE date NOT NULL,
  BMV_VOTE_M TINYINT NOT NULL COMMENT 'More',
  BMV_VOTE_L TINYINT NOT NULL COMMENT 'Less',
  PRIMARY KEY  (ID_BOOKMARK, ID_USER_VOTE),
  KEY BMV_IND_1 (ID_USER_AUT)
) COMMENT = 'Votes Bookmarks';


CREATE TABLE IF NOT EXISTS IM_ROL_ROLE (
  ID_ROLE TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,
  ROL_NAME varchar(40) NOT NULL,
  ROL_DEFAULT char(1) NOT NULL,
  PRIMARY KEY  (ID_ROLE)
) COMMENT = 'Roles';


CREATE TABLE IF NOT EXISTS IM_MDL_MODULE (
  ID_MODULE TINYINT UNSIGNED NOT NULL,
  MDL_NAME varchar(60) NOT NULL,
  MDL_MAX_VALUE INT UNSIGNED NOT NULL default 0,
  MDL_OTHER CHAR(1) NOT NULL default '',
  MDL_ROLE CHAR(1) NOT NULL default '',
  PRIMARY KEY  (ID_MODULE)
) COMMENT = 'Modules/options';


CREATE TABLE IF NOT EXISTS IM_RLM_ROLEMODULE (
  ID_ROLE TINYINT UNSIGNED NOT NULL,
  ID_MODULE TINYINT UNSIGNED NOT NULL,
  RLM_STATE TINYINT UNSIGNED NOT NULL DEFAULT 1,
  RLM_VALUE SMALLINT UNSIGNED NOT NULL,
  PRIMARY KEY (ID_ROLE, ID_MODULE),
  CONSTRAINT im_rlm_rolemodule_fk1 FOREIGN KEY im_rlm_rolemodule_fk1 (ID_ROLE)
    REFERENCES IM_ROL_ROLE (ID_ROLE)
    ON DELETE NO ACTION   ON UPDATE NO ACTION,
  CONSTRAINT im_rlm_rolemodule_fk2 FOREIGN KEY im_rlm_rolemodule_fk2 (ID_MODULE)
    REFERENCES IM_MDL_MODULE (ID_MODULE)
    ON DELETE NO ACTION   ON UPDATE NO ACTION
) COMMENT = 'Roles access to modules';



CREATE TABLE IF NOT EXISTS IM_FMD_FILEMEDIA (
  ID_FILEMEDIA TINYINT UNSIGNED NOT NULL auto_increment ,
  FMD_NAME VARCHAR(30) NOT NULL,
  FMD_EXTENSIONS VARCHAR(200) NOT NULL,
  PRIMARY KEY  (ID_FILEMEDIA)
) COMMENT = 'Share files medias';


CREATE TABLE IF NOT EXISTS IM_FPJ_FILEPROJET (
  ID_PROJET SMALLINT UNSIGNED NOT NULL auto_increment ,
  FPJ_NAME VARCHAR(50) NOT NULL,
  FPJ_FOLDER VARCHAR(20) NOT NULL,
  FPJ_DATE_CREAT date NOT NULL,
  FPJ_DATE_END date NOT NULL default '0000-00-00',
  FPJ_DATE_CLOSE date NOT NULL default '0000-00-00',
  PRIMARY KEY  (ID_PROJET),
  KEY FPJ_DATE_CLOSE (FPJ_DATE_CLOSE)
) COMMENT = 'Share files projets';


CREATE TABLE IF NOT EXISTS IM_FIL_FILE (
  ID_FILE MEDIUMINT UNSIGNED NOT NULL auto_increment,
  FIL_NAME VARCHAR(200) NOT NULL,
  ID_USER_AUT MEDIUMINT NOT NULL,
  ID_USER_DEST MEDIUMINT NULL,
  ID_GROUP_DEST SMALLINT UNSIGNED NULL,
  ID_USER_LAST_DL MEDIUMINT NULL,
  ID_FILEMEDIA TINYINT UNSIGNED NOT NULL,
  ID_PROJET SMALLINT UNSIGNED NULL,
  FIL_ONLINE CHAR(1) NOT NULL,
  FIL_DATE date NOT NULL default '0000-00-00',
  FIL_DATE_ADD date NOT NULL default '0000-00-00',
  FIL_DATE_TRASH date NOT NULL default '0000-00-00',
  FIL_SIZE INT UNSIGNED NULL,
  FIL_HASH CHAR(32) NOT NULL,
  FIL_PROTECT VARCHAR(32) NOT NULL,
  FIL_PASSWORD VARCHAR(32) NOT NULL,
  FIL_COMPRESS CHAR(1) NOT NULL,
  FIL_NB_DOWNLOAD SMALLINT UNSIGNED NOT NULL default '0',
  FIL_NB_ALERT TINYINT UNSIGNED NOT NULL default '0',
  FIL_RATING TINYINT NOT NULL default '0',
  FIL_COMMENT varchar(150) default '' NOT NULL,
  PRIMARY KEY  (ID_FILE),
  KEY FIL_IND_1 (FIL_NAME),
  KEY FIL_IND_2 (ID_USER_AUT, ID_USER_DEST, ID_GROUP_DEST, FIL_ONLINE),
  KEY FIL_IND_3 (ID_FILEMEDIA, ID_PROJET),
  CONSTRAINT im_fil_file_fk1 FOREIGN KEY im_fil_file_fk1 (ID_FILEMEDIA)
    REFERENCES IM_FMD_FILEMEDIA (ID_FILEMEDIA)
    ON DELETE NO ACTION   ON UPDATE NO ACTION,
  CONSTRAINT im_fil_file_fk2 FOREIGN KEY im_fil_file_fk2 (ID_PROJET)
    REFERENCES IM_FPJ_FILEPROJET (ID_PROJET)
    ON DELETE NO ACTION   ON UPDATE NO ACTION
) COMMENT = 'Share files';


CREATE TABLE IF NOT EXISTS IM_FLV_FILEVOTE (
  ID_FILE MEDIUMINT UNSIGNED NOT NULL, 
  ID_USER_VOTE MEDIUMINT NOT NULL, 
  ID_USER_AUT MEDIUMINT NOT NULL COMMENT 'For stats', 
  FLV_DATE date NOT NULL, 
  FLV_VOTE_M TINYINT NOT NULL COMMENT 'More', 
  FLV_VOTE_L TINYINT NOT NULL COMMENT 'Less', 
  PRIMARY KEY  (ID_FILE, ID_USER_VOTE), 
  KEY FLV_IND_1 (ID_USER_AUT),
  CONSTRAINT im_flv_filevote_fk1 FOREIGN KEY im_flv_filevote_fk1 (ID_FILE)
    REFERENCES IM_FIL_FILE (ID_FILE)
    ON DELETE NO ACTION   ON UPDATE NO ACTION,
  ) COMMENT = 'Share files votes';


CREATE TABLE IF NOT EXISTS IM_FST_FILESTATS (
  ID_USER_AUT MEDIUMINT NOT NULL,
  FST_NB_SHARE SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_EXCHANGE SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_ALERT_SEND SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_REJECT SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_VOTE_M SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'More',
  FST_NB_VOTE_L SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Less',
  FST_MAX_VOTE_M SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Score More',
  FST_MAX_VOTE_L SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Score Less',
  FST_NB_LAST_DATE SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Day quota',
  FST_LAST_DATE date NOT NULL,
  FST_NB_LAST_WEEK SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Week quota',
  FST_LAST_WEEK TINYINT UNSIGNED NOT NULL,
  PRIMARY KEY  (ID_USER_AUT)
) COMMENT = 'Stats share files';

CREATE TABLE IF NOT EXISTS IM_FSD_FILESTATSDOWNLOAD (
  ID_USER_DL MEDIUMINT NOT NULL,
  ID_FILE_LAST_DL MEDIUMINT UNSIGNED NOT NULL,
  FSD_NB_DOWNLOAD SMALLINT UNSIGNED NOT NULL default '0',
  FSD_LAST_DATE date NOT NULL,
  FSD_NB_LAST_DATE SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Day quota',
  FSD_TRAFFIC_LAST_DATE MEDIUMINT UNSIGNED NOT NULL default '0',
  FSD_LAST_WEEK TINYINT UNSIGNED NOT NULL default '0',
  FSD_NB_LAST_WEEK SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Week quota',
  FSD_TRAFFIC_LAST_WEEK INT UNSIGNED NOT NULL default '0',
  FSD_LAST_MONTH TINYINT UNSIGNED NOT NULL default '0',
  FSD_NB_LAST_MONTH SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Month quota',
  FSD_TRAFFIC_LAST_MONTH INT UNSIGNED NOT NULL default '0',
  PRIMARY KEY  (ID_USER_DL)
) COMMENT = 'Stats download files';
