ALTER TABLE IM_USR_USER ADD USR_DATE_BIRTH DATE NOT NULL default '0000-00-00' AFTER USR_DATE_ACTIVITY;

ALTER TABLE IM_USR_USER CHANGE USR_IP_ADDRESS USR_IP_ADDRESS varchar(39) NOT NULL default '';

ALTER TABLE IM_MDL_MODULE CHANGE MDL_MAX_VALUE MDL_MAX_VALUE INT UNSIGNED NOT NULL default 0;



ALTER TABLE IM_STA_STATS ADD STA_SF_NB_SHARE MEDIUMINT UNSIGNED NOT NULL default '0';
ALTER TABLE IM_STA_STATS ADD STA_SF_NB_EXCHANGE MEDIUMINT UNSIGNED NOT NULL default '0';



CREATE TABLE IF NOT EXISTS IM_FMD_FILEMEDIA (
  ID_FILEMEDIA TINYINT UNSIGNED NOT NULL auto_increment ,
  FMD_NAME VARCHAR(30) NOT NULL,
  FMD_EXTENSIONS VARCHAR(200) NOT NULL,
  PRIMARY KEY  (ID_FILEMEDIA)
) COMMENT = 'Share files medias';


CREATE TABLE IF NOT EXISTS IM_FPJ_FILEPROJET (
  ID_PROJET SMALLINT UNSIGNED NOT NULL auto_increment ,
  FPJ_NAME VARCHAR(50) NOT NULL,
  FPJ_FOLDER VARCHAR(20) NOT NULL,
  FPJ_DATE_CREAT date NOT NULL,
  FPJ_DATE_END date NOT NULL default '0000-00-00',
  FPJ_DATE_CLOSE date NOT NULL default '0000-00-00',
  PRIMARY KEY  (ID_PROJET),
  KEY FPJ_DATE_CLOSE (FPJ_DATE_CLOSE)
) COMMENT = 'Share files projets';
--  autorise revision ?
--  autorise publication directe (pas d'attente d'approbation) ?


CREATE TABLE IF NOT EXISTS IM_FIL_FILE (
  ID_FILE MEDIUMINT UNSIGNED NOT NULL auto_increment,
  FIL_NAME VARCHAR(200) NOT NULL,
  ID_USER_AUT MEDIUMINT NOT NULL,
  ID_USER_DEST MEDIUMINT NULL,
  ID_GROUP_DEST SMALLINT UNSIGNED NULL,
  ID_USER_LAST_DL MEDIUMINT NULL,
  ID_FILEMEDIA TINYINT UNSIGNED NOT NULL,
  ID_PROJET SMALLINT UNSIGNED NULL,
  FIL_ONLINE CHAR(1) NOT NULL,
  FIL_DATE date NOT NULL default '0000-00-00',
  FIL_DATE_ADD date NOT NULL default '0000-00-00',
  FIL_DATE_TRASH date NOT NULL default '0000-00-00',
  FIL_SIZE INT UNSIGNED NULL,
  FIL_HASH CHAR(32) NOT NULL,
  FIL_PROTECT VARCHAR(32) NOT NULL,
  FIL_PASSWORD VARCHAR(32) NOT NULL,
  FIL_COMPRESS CHAR(1) NOT NULL,
  FIL_NB_DOWNLOAD SMALLINT UNSIGNED NOT NULL default '0',
  FIL_NB_ALERT TINYINT UNSIGNED NOT NULL default '0',
  FIL_RATING TINYINT NOT NULL default '0',
  FIL_COMMENT varchar(150) default '' NOT NULL,
  PRIMARY KEY  (ID_FILE),
  KEY FIL_IND_1 (FIL_NAME),
  KEY FIL_IND_2 (ID_USER_AUT, ID_USER_DEST, ID_GROUP_DEST, FIL_ONLINE),
  KEY FIL_IND_3 (ID_FILEMEDIA, ID_PROJET),
  CONSTRAINT im_fil_file_fk1 FOREIGN KEY im_fil_file_fk1 (ID_FILEMEDIA)
    REFERENCES IM_FMD_FILEMEDIA (ID_FILEMEDIA)
    ON DELETE NO ACTION   ON UPDATE NO ACTION,
  CONSTRAINT im_fil_file_fk2 FOREIGN KEY im_fil_file_fk2 (ID_PROJET)
    REFERENCES IM_FPJ_FILEPROJET (ID_PROJET)
    ON DELETE NO ACTION   ON UPDATE NO ACTION
) COMMENT = 'Share files';
--   FIL_TAGS VARCHAR(100) NOT NULL,
--  FIL_REVISION SMALLINT UNSIGNED NOT NULL,
--  FIL_REMOVE_AFTER_GET CHAR(1) NOT NULL,
--  FIL_REMOVE_AFTER_DAYS TINYINT UNSIGNED NOT NULL default '0',


CREATE TABLE IF NOT EXISTS IM_FLV_FILEVOTE (
  ID_FILE MEDIUMINT UNSIGNED NOT NULL, 
  ID_USER_VOTE MEDIUMINT NOT NULL, 
  ID_USER_AUT MEDIUMINT NOT NULL COMMENT 'For stats', 
  FLV_DATE date NOT NULL, 
  FLV_VOTE_M TINYINT NOT NULL COMMENT 'More', 
  FLV_VOTE_L TINYINT NOT NULL COMMENT 'Less', 
  PRIMARY KEY  (ID_FILE, ID_USER_VOTE), 
  KEY FLV_IND_1 (ID_USER_AUT),
  CONSTRAINT im_flv_filevote_fk1 FOREIGN KEY im_flv_filevote_fk1 (ID_FILE)
    REFERENCES IM_FIL_FILE (ID_FILE)
    ON DELETE NO ACTION   ON UPDATE NO ACTION,
  ) COMMENT = 'Share files votes';


CREATE TABLE IF NOT EXISTS IM_FST_FILESTATS (
  ID_USER_AUT MEDIUMINT NOT NULL,
  FST_NB_SHARE SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_EXCHANGE SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_ALERT_SEND SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_REJECT SMALLINT UNSIGNED NOT NULL default '0',
  FST_NB_VOTE_M SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'More',
  FST_NB_VOTE_L SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Less',
  FST_MAX_VOTE_M SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Score More',
  FST_MAX_VOTE_L SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Score Less',
  FST_NB_LAST_DATE SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Day quota',
  FST_LAST_DATE date NOT NULL,
  FST_NB_LAST_WEEK SMALLINT UNSIGNED NOT NULL default '0' COMMENT 'Week quota',
  FST_LAST_WEEK TINYINT UNSIGNED NOT NULL,
  PRIMARY KEY  (ID_USER_AUT)
) COMMENT = 'Stats share files';
